var express = require("express"),
    qs = require('querystring'),
    fs = require('fs'),
    request = require('request');

var events = require('./js/events');

var app = express.createServer();
app.use(express.bodyParser());

// html or haml??
  app.register('.haml', require('hamljs'));
  app.register('.html', {
    compile: function(str, options){
      return function(locals){
        return str;
      };
    }
  });
  

  app.get('/html', function(req, res){
    res.render('index.html');
  });
  app.get('/', function(req, res){
    res.render('index.haml');
  });

  app.get('/addy',function(req, res){
    res.render('addy.haml');
  });

  app.set('view options', {
    layout: false
  });

// allow models
  app.use("/models", express.static(__dirname + '/models'));

  // view allow
  app.use("/views", express.static(__dirname + '/views'));

// allow dir for js and css
  app.use("/public", express.static(__dirname + '/public'));
  app.use("/js", express.static(__dirname + '/js'));

  app.get("/events/location", function(req, res){
    var url = 'https://www.eventbrite.com/json/event_search?';
    var params = {
	app_key: events.eventbrite_key,
	within: 50,
        date: req.query["date"] || "Today",
	latitude: req.query["latitude"],
	longitude: req.query["longitude"],
	max: req.query["max"]
    };
    url += qs.stringify(params);
	      
    request.get({url:url,json:true}, function (e,r,body) {
    	res.json(events.loadEvent(body));
    }
    );
    // mocked interface
    // var contents = fs.readFileSync('./public/event_output.json','utf8'); 
    // var body = JSON.parse(contents);
    // res.json(events.loadEvent(body));    

  });

  app.get("/events/title",function(req, res){
    var url = 'https://www.eventbrite.com/json/event_search?';
    var params = {
	app_key: events.eventbrite_key,
        keywords: req.query["title"],
        date: req.query["date"] || "Today",
	max: req.query["max"]
    };
    url += qs.stringify(params);
	      
    request.get({url:url,json:true}, function (e,r,body) {
	res.json(events.loadEvent(body));
    }
    );
  });


  app.post('/events/create', function(req, res){
      events.places.push(req.body);
      res.json({success: true, places: events.places});
  });

// listening on port 3000
  var port = process.env.PORT || 3000;
  app.listen(port, function() {
    console.log("Listening on " + port);
  });
