var Spire = require('./spire.io.js');
var spire = new Spire();

spire.start('Ac-0r5GHbS7CFEunAPQT6Gm4Ww-gdIS', function(err, session){
  if (err) throw err;

  spire.subscribe('swag', function (messages) {
    console.log(messages);
  });

    $('#createbox button').on("click", function(e){
      var message = $("form").serialize();
      spire.publish('swag', message, function (err) {
      });
      $(this).slideUp();
  });



  spire.subscribe('swag', {orderBy: 'asc'}, function (messages) {
  // We want the oldest message at the top.
  messages.reverse();
  $(messages).each(function(i, rawMessage){
    var message = rawMessage.content
      , date = new Date(rawMessage.timestamp)
      , mentionedRegex = new RegExp([ '(^|\\s|\\t)'
        , currentUser
        , '(\\s|\\t|:|-|,|$)'
      ].join(''), 'gi')
      , content
      , selector
      , messageElement
    ;

    // Add some helpers to the message object so the template can add
    // some style hooks (classes).
    message.isYou = message.author === currentUser;
    message.cssID = 'message-' + message.id;
    message.humanTime = [ date.getHours()
    , ':'
    , ('0' + date.getMinutes()).slice(-2)
    ].join('');

    // Create a DOM element using the Mustache template (don't add it to
    // the page yet!).
    messageElement = $(ich.message(message));

    // If the `chat.currentUser` is mentioned make sure to add a special
    // class to it.
    if ($(messageElement).find('.body').html().match(mentionedRegex)){
      var html = $(messageElement).find('.body').html()
        , content = html.replace(mentionedRegex, [ '$1'
          , '<span class="mention">'
          , currentUser
          , '</span>$2'
        ].join(''))
      ;

      $(messageElement).find('.body').html(content);
    }

    // Alright, done messing around lets add the `messageElement` to the
    // page and scroll to it, (saving this step to the end helps keep
    // the reflows down).
    $('.messages').append($(messageElement)).scrollTo($(messageElement));
  }); // $(messages)
}); // spire.subscribe

// ## The Initial Overlay Form
  //
  // The overlay form will be the first thing a person sees when running this
  // example, it will ask for the name they will want to use for the chat
  // session. After submitting the name a `join` message will be sent and the
  // the overlay will be hidden.
  $('.overlay form').submit(function(event){
    event.stopPropagation();
    event.preventDefault();

    var form = this
      , nick = $(form).find('input[name="nick"]').val() || 'Anonymous'
      , message
    ;

    // keep track of who you are for later, this will allow us to check if the
    // person chatting is mentioned in another person's message.
    currentUser = nick;

    message = {
      type: 'system',
      body: 'joined',
      author: nick
    };

    spire.publish('spire.io chat example', message, function (err) {
      if (err) throw err;

      // Hide the overlay with the initial form.
      $('.overlay').hide();

      // Focus the input in the footer for a smoother User Experience.
      $('footer form input').focus();
    });
  });


  // The footer form is what handles the actual messages going to everyone in
  // the room. Anything a person types and submits into the form will be
  // displayed to everyone in the room.
  $('footer form').submit(function(event){
    event.stopPropagation();
    event.preventDefault();

    var form = this
      , message = { author: currentUser
          , body: $(form).find('input[name="content"]').val()
      };

    // No message content? don't do anything.
    if (! message.body) return;

    // Send the message constructed above, once the message is sent the
    // `callback` will remove the submitted text and re-focus the input
    spire.publish('spire.io chat example', message, function (err) {
      if (err) throw err;

      $(form).find('input').val('').focus();
    });
  });

});

